package wdpress.tapestry.upload;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringWriter;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.request.IUploadFile;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class UploadPage extends BasePage  {

  private static final Log log = LogFactory.getLog( UploadPage.class );

  private IUploadFile file;
  private String      data;

  public IUploadFile getFile()                    {  return file;  }
  public void        setFile( IUploadFile file )  {  this.file = file;  }

  public String getFileName()  {
    if ( file != null )  return file.getFileName();
    return null;
  }

  public String getData()  {  return data;  }

  public void initialize()  {
    log.info( "initialize" );
    file = null;
    data = null;
  }

  public void detach()  {
    log.info( "detach" );
    file = null;
    data = null;
    super.detach();
  }

  public void formSubmit( IRequestCycle cycle )  {
    log.info( "formSubmit" );
    try  {
      StringWriter out = new StringWriter();
      BufferedReader in = new BufferedReader( new InputStreamReader( file.getStream(), "JISAutoDetect" ) );
      String line;
      while( ( line = in.readLine() ) != null )  {
        out.write( line );
        out.write( "\n" );
      }
      data = out.toString();
      in.close();
      out.close();
    }  catch( Exception ex )  {
      log.warn( ex.getMessage() );
    }
  }
}