/*
 * 쐬: 2003/12/08
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package wdpress.tapestry.album;

import java.io.BufferedInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.form.IPropertySelectionModel;
import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.request.IUploadFile;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import wdpress.tapestry.upload.PictureAsset;
import wdpress.tapestry.upload.PictureService;

/**
 * @author okibayashi
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public abstract class AlbumPage
	extends BasePage
	implements PageRenderListener {

		private static final Log log = LogFactory.getLog( AlbumPage.class );

		private byte[] buff = new byte[ 4096 ];
		public IPropertySelectionModel model;

		public abstract List         getSelectedList();
		public abstract void         setSelectedList( List value );
		public abstract PictureAsset getSelectedAsset();
		public abstract void         setSelectedAsset( PictureAsset value );
		public abstract IUploadFile  getAlbumFile();
		public abstract void         setAlbumFile( IUploadFile value );

		public void initialize()  {
		  log.info( "initialize" );
		  model = null;
		  addPageRenderListener( this );
		  setSelectedList( new ArrayList() );
		}

		public void detach()  {
		  log.info( "detach" );
		  model = null;
		  super.detach();
		}

	/* ( Javadoc)
	 * @see org.apache.tapestry.event.PageRenderListener#pageBeginRender(org.apache.tapestry.event.PageEvent)
	 */
	public void pageBeginRender(PageEvent event) {
		log.info( "pageBeginRender" );
		String albumDir = getAlbumDir( event.getRequestCycle() );
		String[] albumFiles = new File( albumDir ).list();
		if ( albumFiles == null )  return;
		PictureAsset[] assets = new PictureAsset[ albumFiles.length ];
		for( int i = 0; i < albumFiles.length; i++ )  {
		  String type = albumFiles[ i ].substring( albumFiles[ i ].lastIndexOf( '.' ) + 1 );
		  if ( type.equalsIgnoreCase( "jpg" ) )  type = "jpeg";
		  assets[ i ] = new PictureAsset( albumFiles[ i ], type );
		}
		model = new AlbumPropertySelectionModel( assets );
	}

	public void pageEndRender( PageEvent event )  {
	  log.info( "pageEndRender" );
	  model = null;
	}

	public void displayAction( IRequestCycle requestCycle )  {
	  log.info( "displayAction" );
	}

	public void deleteAction( IRequestCycle requestCycle )  {
	  log.info( "deleteAction : size = " + getSelectedList().size() );
	  for( int i = 0; i < getSelectedList().size(); i++ )  {
		PictureAsset asset = (PictureAsset)getSelectedList().get( i );
		String fileName = ( asset ).getFileName();
		File albumFile = new File( getFullPath( requestCycle, fileName ) );
		if ( albumFile.exists() )  {
		  albumFile.delete();
		  log.info( "deleteAction : DeletedFile = " + albumFile.getName() );
		}
	  }
	  getSelectedList().clear();
	}

	public void uploadAction( IRequestCycle requestCycle )  {
	  log.info( "uploadAction" );
	  saveAlbum( getAlbumFile(),
				 getFullPath( requestCycle, getAlbumFile().getFileName() ) );
	  log.info( "uploadAction - fileName = " + getAlbumFile().getFileName()
				+ ", type = "   + getAlbumFile().getContentType() );
	}

	private void saveAlbum( IUploadFile inFile, String outFile )  {
	  log.info( "saveAlbum" );
	  try  {
		BufferedInputStream in = new BufferedInputStream( inFile.getStream() );
		DataOutputStream out =
					new DataOutputStream( new FileOutputStream( outFile ) );
		int len, sum = 0;
		while( ( len = in.read( buff, 0, buff.length ) ) >= 0 )  {
		  out.write( buff, 0, len );
		  out.flush();
		  sum += len;
		}
		out.close();
		in.close();
		log.info( "saveAlbum : sum = " + sum );
	  }  catch( Exception ex )  {
		log.warn( ex.getMessage() );
	  }
	}

	private String getFullPath( IRequestCycle cycle, String fileName )  {
	  return getAlbumDir( cycle ) + File.separator + fileName;
	}

	private String getAlbumDir( IRequestCycle cycle )  {
	  return PictureService.getPictPath( cycle, PictureService.PICTURE_PATH );
	}

}
