/*
 * 쐬: 2003/12/08
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package wdpress.tapestry.upload;

import java.io.IOException;

import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;

import javax.servlet.ServletException;

import org.apache.tapestry.IComponent;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.engine.AbstractService;
import org.apache.tapestry.engine.IEngineServiceView;
import org.apache.tapestry.engine.ILink;
import org.apache.tapestry.request.ResponseOutputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author okibayashi
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class PictureService extends AbstractService {

	private static final Log log = LogFactory.getLog( PictureService.class );

	public static final String SERVICE_NAME = "picture";
	public static final String PICTURE_PATH = "/WEB-INF/picture";

	/* ( Javadoc)
	 * @see org.apache.tapestry.engine.IEngineService#getName()
	 */
	public String getName() {
		return SERVICE_NAME;
	}

	/* ( Javadoc)
	 * @see org.apache.tapestry.engine.IEngineService#service(org.apache.tapestry.engine.IEngineServiceView, org.apache.tapestry.IRequestCycle, org.apache.tapestry.request.ResponseOutputStream)
	 */
	public void service(
		IEngineServiceView engine,
		IRequestCycle requestCycle,
		ResponseOutputStream output)
		throws ServletException, IOException {
		String[] context  = getServiceContext( requestCycle.getRequestContext() );
		String   type     = context[ 0 ];
		String   fileName = context[ 1 ];
		String   encoding = requestCycle.getRequestContext()
								  .getRequest().getCharacterEncoding();
		if ( encoding == null )  encoding = "Shift_JIS";
		fileName = new String( fileName.getBytes( "ISO-8859-1" ), encoding );
		log.info( "service" );
		log.info( "fileName = " + fileName + ", type = " + type );
		try  {
		  String pictFile =
			getPictPath( requestCycle, PICTURE_PATH + File.separator + fileName );
		  DataInputStream in =
			  new DataInputStream( new FileInputStream( pictFile ) );
		  BufferedOutputStream out = new BufferedOutputStream( output );
		  output.setContentType( "image/" + type );
		  byte[] buff = new byte[ 4096 ];
		  int len, sum = 0;
		  while ( ( len = in.read( buff ) ) >= 0 )  {
			out.write( buff, 0, len );
			out.flush();
			sum += len;
		  }
		  log.info( "sum = " + sum );
		  out.close();
		  in.close();
		}  catch( java.io.FileNotFoundException ex )  {
		  engine.reportException( "摜t@C܂", ex );
		}  catch (Throwable ex)  {
		  engine.reportException("摜\邱Ƃł܂", ex);
		}
	}

	/* ( Javadoc)
	 * @see org.apache.tapestry.engine.IEngineService#getLink(org.apache.tapestry.IRequestCycle, org.apache.tapestry.IComponent, java.lang.Object[])
	 */
	public ILink getLink(IRequestCycle requestCycle, IComponent component, Object[] param) {
		String[] context = new String[ param.length ];
		for( int i = 0; i < context.length; i++ )  {
		  context[ i ] = (String)param[ i ];
		}
		return constructLink( requestCycle, SERVICE_NAME, context, null, true );
	}

	public static String getPictPath( IRequestCycle reqCycle, String path )  {
	  return reqCycle.getRequestContext().getServlet()
								  .getServletContext().getRealPath( path );
	}


}
